Attribute VB_Name = "CANIO"
Const CAN_TXB0 As Integer = 3904
Const CAN_RXB0 As Integer = 3936
Const CAN_CON As Integer = 3951
Const CAN_STAT As Integer = 3956
Const CAN_BRG As Integer = 3952
Const CAN_IOCON As Integer = 3955
Const CAN_FLTRS As Integer = 3840
Const CAN_MASKS As Integer = 3864
Const CAN_DDR As Integer = 3987




Function CANInit(Filt0 As Long, Filt1 As Long, Mask0 As Long, Brg As Long) As Integer
    ReDim CANMaskFilter(38) As Byte
        
    CANMaskFilter(0) = (Filt0 \ 16777216) And 255
    CANMaskFilter(1) = (Filt0 \ 65536) And 255
    CANMaskFilter(2) = (Filt0 \ 256) And 255
    CANMaskFilter(3) = Filt0 And 255
    
    CANMaskFilter(4) = (Filt1 \ 16777216) And 255
    CANMaskFilter(5) = (Filt1 \ 65536) And 255
    CANMaskFilter(6) = (Filt1 \ 256) And 255
    CANMaskFilter(7) = Filt1 And 255
    
    CANMaskFilter(8) = 0
    CANMaskFilter(9) = 0
    CANMaskFilter(10) = 0
    CANMaskFilter(11) = 0
    
    CANMaskFilter(12) = 0
    CANMaskFilter(13) = 0
    CANMaskFilter(14) = 0
    CANMaskFilter(15) = 0
    
    CANMaskFilter(16) = 0
    CANMaskFilter(17) = 0
    CANMaskFilter(18) = 0
    CANMaskFilter(19) = 0
    
    CANMaskFilter(20) = 0
    CANMaskFilter(21) = 0
    CANMaskFilter(22) = 0
    CANMaskFilter(23) = 0
    
    CANMaskFilter(24) = (Mask0 \ 16777216) And 255
    CANMaskFilter(25) = (Mask0 \ 65536) And 255
    CANMaskFilter(26) = (Mask0 \ 256) And 255
    CANMaskFilter(27) = Mask0 And 255
    
    CANMaskFilter(28) = 255
    CANMaskFilter(29) = 255
    CANMaskFilter(30) = 255
    CANMaskFilter(31) = 255
    CANInit = WriteSRAM(myPortHandle, CAN_FLTRS, 32, CANMaskFilter)
    
    
    CANMaskFilter(0) = Brg And 255
    CANMaskFilter(1) = (Brg \ 256) And 255
    CANMaskFilter(2) = (Brg \ 65536) And 255
    CANMaskFilter(3) = 32
    CANInit = WriteSRAM(myPortHandle, CAN_BRG, 4, CANMaskFilter)
    
    
    CANMaskFilter(0) = 0
    CANInit = WriteSRAM(myPortHandle, CAN_CON, 1, CANMaskFilter)
    
    CANMaskFilter(0) = 251
    CANInit = WriteSRAM(myPortHandle, CAN_DDR, 1, CANMaskFilter)
    
    Erase CANMaskFilter
    
End Function




Function CANPutData(CANIdent As Long, CANCount As Byte, CANTXData() As Byte) As Integer
    ReDim DataBuffer(20) As Byte
    
    'Wait for an empty transmit buffer
    Do
        DataBuffer = ReadSRAM(myPortHandle, CAN_TXB0, 1)
     '   Exit Function
    Loop Until (DataBuffer(0) And 8) = 0
    
    ReDim DataBuffer(20) As Byte
    
    'Load the ID, count, and data
    DataBuffer(0) = (CANIdent \ 16777216) And 255
    DataBuffer(1) = (CANIdent \ 65536) And 255
    DataBuffer(2) = (CANIdent \ 256) And 255
    DataBuffer(3) = CANIdent And 255
    DataBuffer(4) = CANCount
    
    For i = 0 To CANCount - 1
        DataBuffer(i + 5) = CANTXData(i)
    Next i
    
    CANPutData = WriteSRAM(myPortHandle, CAN_TXB0 + 1, 5 + CANCount, DataBuffer)
    
    'Request to start sending the message
    DataBuffer(0) = 8
    CANPutData = WriteSRAM(myPortHandle, CAN_TXB0, 1, DataBuffer)
    
End Function


Function CANGetData() As Byte()


End Function



