VERSION 5.00
Begin VB.UserControl CANComm 
   CanGetFocus     =   0   'False
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   InvisibleAtRuntime=   -1  'True
   Picture         =   "MCHP_CAN.ctx":0000
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   ToolboxBitmap   =   "MCHP_CAN.ctx":1072
   Windowless      =   -1  'True
End
Attribute VB_Name = "CANComm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Const CAN_TXB0 As Integer = 3904
Const CAN_TXB1 As Integer = 3888
Const CAN_TXB2 As Integer = 3872
Const CAN_RXB0 As Integer = 3936
Const CAN_RXB1 As Integer = 3920
Const CAN_CON As Integer = 3951
Const CAN_STAT As Integer = 3956
Const CAN_BRG As Integer = 3952
Const CAN_IOCON As Integer = 3955
Const CAN_FLTRS As Integer = 3840
Const CAN_MASKS As Integer = 3864
Const CAN_DDR As Integer = 3987


Public Type mchpCANmsg
    CANId As Long
    CANExtnd As Boolean
    CANRTR As Boolean
    CANDatLen As Byte
    CANData() As Byte
End Type


Public Enum mchpCANFilters
    mchp_Filt0 = 3840
    mchp_Filt1 = 3844
    mchp_Filt2 = 3848
    mchp_Filt3 = 3852
    mchp_Filt4 = 3856
    mchp_Filt5 = 3860
End Enum

Public Enum mchpCANMasks
    mchp_Mask0 = 3864
    mchp_Mask1 = 3868
End Enum


Public Enum mchpCANTxBuf
    mchp_TXB0 = CAN_TXB0
    mchp_TXB1 = CAN_TXB1
    mchp_TXB2 = CAN_TXB2
End Enum

Public Enum mchpCANRxBuf
    mchp_RXB0 = CAN_RXB0
    mchp_RXB1 = CAN_RXB1
End Enum


Public Enum mchpSerialPort
    mchp_COM1 = 1
    mchp_COM2
    mchp_COM3
    mchp_COM4
End Enum


Public Enum mchp1to4Tq
    mchpa_1xTq = 0
    mchpa_2xTq
    mchpa_3xTq
    mchpa_4xTq
End Enum


Public Enum mchp1to8Tq
    mchp_1xTq = 0
    mchp_2xTq
    mchp_3xTq
    mchp_4xTq
    mchp_5xTq
    mchp_6xTq
    mchp_7xTq
    mchp_8xTq
End Enum


Public Type mchpCANControl
    mchp_SJW As mchp1to4Tq
    mchp_BRP As Integer
    
    mchp_SEG2PHTS As Boolean
    mchp_SAM As Boolean
    mchp_SEG1PH As mchp1to8Tq
    mchp_PRSEG As mchp1to8Tq
    
    mchp_WAKFIL As Boolean
    mchp_SEG2PH As mchp1to8Tq
    
    mchp_ENDRHI As Boolean
    mchp_CANCAP As Boolean
End Type

    

    


'Default Property Values:
Const m_def_BitRate = 57600
Const m_def_CommPort = mchpSerialPort.mchp_COM2
Const m_def_hPortHandle = -1
Const m_def_MaxTimeOut = 1000
Const m_def_MaxRetrys = 3


'Property Variables:
Dim m_MaxRetrys As Integer
Dim m_MaxTimeOut As Long
Dim m_hPortHandle As Long
Dim m_BitRate As Long
Dim m_CommPort As mchpSerialPort







'Event Declarations:






Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property











Public Property Get BitRate() As Long
    BitRate = m_BitRate
End Property

Public Property Let BitRate(ByVal New_BitRate As Long)
    m_BitRate = New_BitRate
    PropertyChanged "BitRate"
End Property


Public Property Get CommPort() As mchpSerialPort
    CommPort = m_CommPort
End Property

Public Property Let CommPort(ByVal New_CommPort As mchpSerialPort)
    m_CommPort = New_CommPort
    PropertyChanged "CommPort"
End Property



Public Property Get MaxTimeOut() As Long
    MaxTimeOut = m_MaxTimeOut
End Property

Public Property Let MaxTimeOut(ByVal New_MaxTimeOut As Long)
    m_MaxTimeOut = New_MaxTimeOut
    PropertyChanged "MaxTimeOut"
End Property


Public Property Get MaxRetrys() As Integer
    MaxRetrys = m_MaxRetrys
End Property

Public Property Let MaxRetrys(ByVal New_MaxRetrys As Integer)
    m_MaxRetrys = New_MaxRetrys
    PropertyChanged "MaxRetrys"
End Property










Public Sub SetFilter(CANFilter As Long, Optional CANExtended As Boolean = True, Optional CANFilterAddr As mchpCANFilters = mchp_Filt0)
    Dim CANPacket As mchpCANmsg
    ReDim DataBuff(4) As Byte
    
    CANPacket.CANId = CANFilter
    CANPacket.CANExtnd = CANExtended
    DataBuff = DecodeId(CANPacket)

    If WriteSRAM(m_hPortHandle, m_MaxRetrys, CInt(CANFilterAddr), 4, DataBuff()) <= 0 Then
        Err.Raise 5002, VB.App.Title, "Communication failure", vbEmpty, vbEmpty
    End If

End Sub


Public Sub SetMask(CANMask As Long, Optional CANExtended As Boolean = True, Optional CANMaskAddr As mchpCANMasks = mchp_Mask0)
    Dim CANPacket As mchpCANmsg
    ReDim DataBuff(4) As Byte
    
    CANPacket.CANId = CANMask
    CANPacket.CANExtnd = CANExtended
    DataBuff = DecodeId(CANPacket)
    
    If WriteSRAM(m_hPortHandle, m_MaxRetrys, CInt(CANMaskAddr), 8, DataBuff()) <= 0 Then
        Err.Raise 5002, VB.App.Title, "Communication failure", vbEmpty, vbEmpty
    End If
End Sub


Public Function GetMsg(Optional CANRxBuf As mchpCANRxBuf = mchp_RXB0) As mchpCANmsg
    ReDim DataBuff(13) As Byte
    ReDim GetMsg.CANData(8) As Byte

    'Read the data from the CAN receive buffer
    If ReadSRAM(m_hPortHandle, m_MaxRetrys, CInt(CANRxBuf + 1), 13, DataBuff()) <= 0 Then
        Err.Raise 5002, VB.App.Title, "Communication failure", vbEmpty, vbEmpty
        Exit Function
    End If

    'Encode the ID received
    GetMsg = EncodeId(DataBuff())
    
    ReDim Preserve DataBuff(13) As Byte
    ReDim Preserve GetMsg.CANData(8) As Byte

    'Get the data from the buffer
    For i = 0 To 7
        GetMsg.CANData(i) = DataBuff(5 + i)
    Next i
    
    'Get the data count
    GetMsg.CANDatLen = DataBuff(5) And 15

    'Get the RTR
    If (DataBuff(5) And 64) = 0 Then
        GetMsg.CANRTR = False
    Else
        GetMsg.CANRTR = True
    End If
    
    'Open the buffer for another write
    DataBuff(0) = 0
    If WriteSRAM(m_hPortHandle, m_MaxRetrys, CInt(CANRxBuf), 1, DataBuff()) <= 0 Then
        Err.Raise 5002, VB.App.Title, "Communication failure", vbEmpty, vbEmpty
        Exit Function
    End If
End Function


Public Function PutMsg(CANPacket As mchpCANmsg, Optional CANTxBuf As mchpCANTxBuf = mchp_TXB0) As Integer
    ReDim DataBuff(13) As Byte
    ReDim Preserve CANPacket.CANData(8)
    
    'Verify a valid count
    If CANPacket.CANDatLen > 8 Then
        Err.Raise 5003, VB.App.Title, "CAN data length must not be greater than 8.", vbEmpty, vbEmpty
        Exit Function
    End If
    
    'Reformat the ID for the CAN module
    DataBuff = DecodeId(CANPacket)
        
    ReDim Preserve DataBuff(13) As Byte
        
    'Store the data length
    DataBuff(4) = CANPacket.CANDatLen
    
    'Based on the RTR, store the data
    If CANPacket.CANRTR Then
        DataBuff(4) = DataBuff(4) + 64
    Else
        For i = 0 To (CANPacket.CANDatLen - 1)
            DataBuff(5 + i) = CANPacket.CANData(i)
        Next i
    End If
    
    'Load the transmit buffer on the module
    If WriteSRAM(m_hPortHandle, m_MaxRetrys, CInt(CANTxBuf + 1), 5 + CANPacket.CANDatLen, DataBuff()) <= 0 Then
        Err.Raise 5002, VB.App.Title, "Communication failure", vbEmpty, vbEmpty
        Exit Function
    End If
    
    'Enable the transmission
    DataBuff(0) = 8
    If WriteSRAM(m_hPortHandle, m_MaxRetrys, CInt(CANTxBuf), 1, DataBuff()) <= 0 Then
        Err.Raise 5002, VB.App.Title, "Communication failure", vbEmpty, vbEmpty
        Exit Function
    End If
End Function



Private Function DecodeId(CANPacket As mchpCANmsg) As Byte()
    ReDim DataBuff(4) As Byte

    If CANPacket.CANExtnd Then
        DataBuff(0) = (CANPacket.CANId And 534773760) \ 2097152
        DataBuff(1) = ((CANPacket.CANId And 1835008) \ 8192) + ((CANPacket.CANId And 196608) \ 65536) + 8
        DataBuff(2) = (CANPacket.CANId And 65280) \ 256
        DataBuff(3) = (CANPacket.CANId And 255)
    Else
        DataBuff(0) = (CANPacket.CANId And 2040) \ 8
        DataBuff(1) = (CANPacket.CANId And 7) * 32
        DataBuff(2) = 0
        DataBuff(3) = 0
    End If
    
    DecodeId = DataBuff
End Function

Private Function EncodeId(CANData() As Byte) As mchpCANmsg
    If (CANData(1) And 8) > 0 Then
        EncodeId.CANId = CANData(0) * 2097152
        EncodeId.CANId = EncodeId.CANId + ((CANData(1) And 224) * 8192)
        EncodeId.CANId = EncodeId.CANId + ((CANData(1) And 3) * 65536)
        EncodeId.CANId = EncodeId.CANId + (CANData(2) * 256)
        EncodeId.CANId = EncodeId.CANId + CANData(3)
        EncodeId.CANExtnd = True
    Else
        EncodeId.CANId = CANData(0) * 8
        EncodeId.CANId = EncodeId.CANId + ((CANData(1) And 224) \ 32)
        EncodeId.CANExtnd = False
    End If
End Function



Public Sub SetBitRate(CANControl As mchpCANControl)
    ReDim DataBuff(3) As Byte

    'Setup BRGCON1
    DataBuff(0) = ((CANControl.mchp_SJW And 3) * 64) + (CANControl.mchp_BRP And 63)
    
    'Setup BRG2CON
    DataBuff(1) = ((CANControl.mchp_SEG1PH And 7) * 8) + (CANControl.mchp_PRSEG And 7)
    If CANControl.mchp_SEG2PHTS Then DataBuff(1) = DataBuff(1) + 128
    If CANControl.mchp_SAM Then DataBuff(1) = DataBuff(1) + 64
    
    'Setup BRG3CON
    DataBuff(2) = CANControl.mchp_SEG2PH And 7
    If CANControl.mchp_WAKFIL Then DataBuff(2) = DataBuff(2) + 64
    
    'Send the data to the device
    If WriteSRAM(m_hPortHandle, m_MaxRetrys, CAN_BRG, 3, DataBuff()) <= 0 Then
        Err.Raise 5002, VB.App.Title, "Communication failure", vbEmpty, vbEmpty
        Exit Sub
    End If
End Sub


Public Sub Init(CANControl As mchpCANControl)
    ReDim DataBuff(1) As Byte

    DataBuff(0) = 0
    If CANControl.mchp_CANCAP Then DataBuff(0) = DataBuff(0) + 16
    If CANControl.mchp_ENDRHI Then DataBuff(0) = DataBuff(0) + 32
    
    'Send the data to the device
    If WriteSRAM(m_hPortHandle, m_MaxRetrys, CAN_IOCON, 1, DataBuff()) <= 0 Then
        Err.Raise 5002, VB.App.Title, "Communication failure", vbEmpty, vbEmpty
        Exit Sub
    End If
    
    'Setup TX and RX pin directions
    DataBuff(0) = 251
    
    'Send the data to the device
    If WriteSRAM(m_hPortHandle, m_MaxRetrys, CAN_DDR, 1, DataBuff()) <= 0 Then
        Err.Raise 5002, VB.App.Title, "Communication failure", vbEmpty, vbEmpty
        Exit Sub
    End If
  
End Sub




Public Function IsGetMsgRdy(Optional CANRxBuf As mchpCANRxBuf = mchp_RXB0) As Boolean
    ReDim DataBuff(1) As Byte
    
    'Read the data from the CAN receive buffer
    If ReadSRAM(m_hPortHandle, m_MaxRetrys, CInt(CANRxBuf), 1, DataBuff()) <= 0 Then
        Err.Raise 5002, VB.App.Title, "Communication failure", vbEmpty, vbEmpty
        Exit Function
    End If
    
    If (DataBuff(0) And 128) = 0 Then
        IsGetMsgRdy = False
    Else
        IsGetMsgRdy = True
    End If

End Function



Public Function IsPutMsgRdy(Optional CANTxBuf As mchpCANTxBuf = mchp_TXB0) As Boolean
    ReDim DataBuff(1) As Byte
    
    'Read the data from the CAN receive buffer
    If ReadSRAM(m_hPortHandle, m_MaxRetrys, CInt(CANTxBuf), 1, DataBuff()) <= 0 Then
        Err.Raise 5002, VB.App.Title, "Communication failure", vbEmpty, vbEmpty
        Exit Function
    End If
    
    If (DataBuff(0) And 8) = 0 Then
        IsPutMsgRdy = True
    Else
        IsPutMsgRdy = False
    End If

End Function






Public Sub GoOnBus()
    ReDim DataBuff(1) As Byte

    'Setup Normal mode
    DataBuff(0) = 0
    
    'Send the data to the device
    If WriteSRAM(m_hPortHandle, m_MaxRetrys, CAN_CON, 1, DataBuff()) <= 0 Then
        Err.Raise 5002, VB.App.Title, "Communication failure", vbEmpty, vbEmpty
        Exit Sub
    End If

End Sub




Public Sub GoOffBus()
    ReDim DataBuff(1) As Byte

    'Setup Loopback
    DataBuff(0) = 64
    
    'Send the data to the device
    If WriteSRAM(m_hPortHandle, m_MaxRetrys, CAN_CON, 1, DataBuff()) <= 0 Then
        Err.Raise 5002, VB.App.Title, "Communication failure", vbEmpty, vbEmpty
        Exit Sub
    End If
    
    'Setup Config
    DataBuff(0) = 96
    
    'Send the data to the device
    If WriteSRAM(m_hPortHandle, m_MaxRetrys, CAN_CON, 1, DataBuff()) <= 0 Then
        Err.Raise 5002, VB.App.Title, "Communication failure", vbEmpty, vbEmpty
        Exit Sub
    End If
End Sub



Public Function GetStat() As Byte
    ReDim DataBuff(1) As Byte
    
    'Read the data from the CAN receive buffer
    If ReadSRAM(m_hPortHandle, m_MaxRetrys, CAN_STAT, 1, DataBuff()) <= 0 Then
        Err.Raise 5002, VB.App.Title, "Communication failure", vbEmpty, vbEmpty
        Exit Function
    End If
    
    GetStat = DataBuff(0)
End Function








Public Sub OpenComm()
    Dim myCommPort As String
    
    myCommPort = "COM" & CStr(m_CommPort)

    m_hPortHandle = OpenPIC(myCommPort, m_BitRate, m_MaxTimeOut)
        
    If m_hPortHandle <= 0 Then
        Err.Raise 5000, VB.App.Title, "Failed to open port", vbEmpty, vbEmpty
    End If
End Sub




Public Sub CloseComm()
    If ClosePIC(m_hPortHandle) <= 0 Then
        Err.Raise 5001, VB.App.Title, "Port not open or invalid handle", vbEmpty, vbEmpty
    End If
End Sub











'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_MaxRetrys = m_def_MaxRetrys
    m_BitRate = m_def_BitRate
    m_CommPort = m_def_CommPort
    m_hPortHandle = m_def_hPortHandle
    m_MaxTimeOut = m_def_MaxTimeOut
End Sub



'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    m_BitRate = PropBag.ReadProperty("BitRate", m_def_BitRate)
    m_CommPort = PropBag.ReadProperty("CommPort", m_def_CommPort)
 '   m_hPortHandle = PropBag.ReadProperty("hPortHandle", m_def_hPortHandle)
    m_MaxTimeOut = PropBag.ReadProperty("MaxTimeOut", m_def_MaxTimeOut)
    m_MaxRetrys = PropBag.ReadProperty("MaxRetrys", m_def_MaxRetrys)
End Sub



'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("BitRate", m_BitRate, m_def_BitRate)
    Call PropBag.WriteProperty("CommPort", m_CommPort, m_def_CommPort)
 '   Call PropBag.WriteProperty("hPortHandle", m_hPortHandle, m_def_hPortHandle)
    Call PropBag.WriteProperty("MaxTimeOut", m_MaxTimeOut, m_def_MaxTimeOut)
    Call PropBag.WriteProperty("MaxRetrys", m_MaxRetrys, m_def_MaxRetrys)
End Sub



Private Sub UserControl_Initialize()
    UserControl.Height = 570
    UserControl.Width = 570
End Sub


Private Sub UserControl_Resize()
    UserControl.Height = 570
    UserControl.Width = 570
End Sub
